//+------------------------------------------------------------------+
//|                                                    YZCHMC_V1.mq4 |
//|                                           YURAZ Copyright  2008 |
//|                                          www.mail.ru yzh@mail.ru |
//+------------------------------------------------------------------+

//
//   
//

#property copyright "YURAZ Copyright  2008"
#property link      "www.mail.ru yzh@mail.ru"

#property indicator_separate_window

#include <inifiles.mqh> //    ,  !


// API
//     /   
#import "kernel32.dll"
int  FindFirstFileA(string path, int & answer[]);
bool FindClose(int handle);
#import

int win32_DATA[80]; //     FindFirstFileA
 
extern string sFileINI = "YZCHMC_V1.INI";


string sNameIndicator="YZCHMC_V1";
string sPathApp;
string sPathFileINI;

//
string sVERSION;
int  giCountSymbol;

string sSymbol[];

void InitializeINIFile( ) // string &sSymbol[] )
{
   int i;
   
   
   sPathApp = TerminalPath(); //     
   sPathFileINI = StringConcatenate ( sPathApp ,"\\", sFileINI);
   
   //        -         
   int handle = FindFirstFileA(sPathFileINI , win32_DATA); 

   if ( handle >= 1 ) // 
   {
       //  
       FindClose(handle);
       sVERSION     = ReadIniString( sPathFileINI ,  "DATEVERSION", "DATE", "");
       giCountSymbol = ReadIniInteger( sPathFileINI , "COUNTSYMBOL", "COUNTSYMBOL", 0);              

       ArrayResize( sSymbol, giCountSymbol    );

       for (  i=0; i < giCountSymbol; i++ )
       {
           string sI =  i;
           sSymbol[i] = ReadIniString( sPathFileINI , "SYMBOL", StringTrimRight (  StringTrimLeft  (sI) ) , "" );

      Print(" > "+0+" "+sSymbol[0]+" "+giCountSymbol+" - sI= ["+sI+"] i="+i  );
      Print(" > "+1+" "+sSymbol[1]+" "+giCountSymbol  );
      Print(" > "+2+" "+sSymbol[2]+" "+giCountSymbol  );
      Print(" > "+i+" "+sSymbol[i]+" "+giCountSymbol+" - sI= ["+sI+"] i="+i  );
      Print(" --- " );

           
       }
     

      Print(" > "+0+" "+sSymbol[0]+" "+giCountSymbol  );
      Print(" > "+1+" "+sSymbol[1]+" "+giCountSymbol  );
      Print(" > "+2+" "+sSymbol[2]+" "+giCountSymbol  );
      Print(" > "+3+" "+sSymbol[3]+" "+giCountSymbol  );
      Print(" > "+4+" "+sSymbol[4]+" "+giCountSymbol  );
      Print(" > "+5+" "+sSymbol[5]+" "+giCountSymbol  );
      Print(" > "+6+" "+sSymbol[6]+" "+giCountSymbol  );


        
        
   }
   else
   {
       giCountSymbol = 53;

       //    -       MRC - MoneyRain

       WriteIniString ( sPathFileINI ,  "DATEVERSION", "DATE", "2008.10.21");
       WriteIniString ( sPathFileINI ,  "VERSION", "VERSION", "V1.S000001");
       WriteIniInteger( sPathFileINI ,  "COUNTSYMBOL", "COUNTSYMBOL", giCountSymbol );              
       ArrayResize( sSymbol, giCountSymbol+2);

       sSymbol[ 0]="EURUSD";
       sSymbol[ 1]="GPBUSD";
       sSymbol[ 2]="AUDUSD";
       sSymbol[ 3]="NZDUSD";
       sSymbol[ 4]="USDCAD";
       sSymbol[ 5]="USDCHF";
       sSymbol[ 6]="USDALL";
       sSymbol[ 7]="USDARS";
       sSymbol[ 8]="USDBRL";
       sSymbol[ 9]="USDBWP";
       sSymbol[10]="USDCLP";
       sSymbol[11]="USDCNY";
       sSymbol[12]="USDCOP";
       sSymbol[13]="USDCVE";
       sSymbol[14]="USDCZK";
       sSymbol[15]="USDDKK";
       sSymbol[16]="USDDOP";
       sSymbol[17]="USDDZD";
       sSymbol[18]="USDEGP";
       sSymbol[19]="USDGEL";
       sSymbol[20]="USDGIP";
       sSymbol[21]="USDHKD";
       sSymbol[22]="USDHRK";
       sSymbol[23]="USDHUF";
       sSymbol[24]="USDIDR";
       sSymbol[25]="USDILS";
       sSymbol[26]="USDINR";
       sSymbol[27]="USDIRR";
       sSymbol[28]="USDISK";
       sSymbol[29]="USDJPY";
       sSymbol[30]="USDKRW";
       sSymbol[31]="USDLBP";
       sSymbol[32]="USDLSL";
       sSymbol[33]="USDMAD";
       sSymbol[34]="USDMXN";
       sSymbol[35]="USDMYR";
       sSymbol[36]="USDNOK";
       sSymbol[37]="USDNPR";
       sSymbol[38]="USDPHP";
       sSymbol[39]="USDPKR";
       sSymbol[40]="USDPLN";
       sSymbol[41]="USDQAR";
       sSymbol[42]="USDRUB";
       sSymbol[43]="USDSAR";
       sSymbol[44]="USDSEK";
       sSymbol[45]="USDSGD";
       sSymbol[46]="USDTND";
       sSymbol[47]="USDTRY";
       sSymbol[48]="USDTWD";
       sSymbol[49]="USDUAH";
       sSymbol[50]="USDXOF";
       sSymbol[51]="USDZAR";
       sSymbol[52]="USDZMK";
       sSymbol[53]="";
       for (  i=0; i < giCountSymbol;i++ )
       {

           string sIw =  i;
           WriteIniString( sPathFileINI , "SYMBOL", StringTrimRight (  StringTrimLeft  (sIw) ) , sSymbol[i]);
           Print(" w> "+i+" "+sSymbol[i]+" "+giCountSymbol  );
       }
      
   }

      Print(" > "+0+" "+sSymbol[0]+" "+giCountSymbol  );
      Print(" > "+1+" "+sSymbol[1]+" "+giCountSymbol  );
      Print(" > "+2+" "+sSymbol[2]+" "+giCountSymbol  );
      Print(" > "+3+" "+sSymbol[3]+" "+giCountSymbol  );
      Print(" > "+4+" "+sSymbol[4]+" "+giCountSymbol  );
      Print(" > "+5+" "+sSymbol[5]+" "+giCountSymbol  );
      Print(" > "+6+" "+sSymbol[6]+" "+giCountSymbol  );


}
/////////////////////


int init()
  {
Print( " INIT ");

   IndicatorShortName( sNameIndicator) ;
   //DrawSymbol();

   InitializeINIFile( );  // (sSymbol  );

      Print("i > "+0+" "+sSymbol[0]+" "+giCountSymbol  );
      Print("i > "+1+" "+sSymbol[1]+" "+giCountSymbol  );
      Print("i > "+2+" "+sSymbol[2]+" "+giCountSymbol  );
      Print("i > "+3+" "+sSymbol[3]+" "+giCountSymbol  );
      Print("i > "+4+" "+sSymbol[4]+" "+giCountSymbol  );
      Print("i > "+5+" "+sSymbol[5]+" "+giCountSymbol  );
      Print("i > "+6+" "+sSymbol[6]+" "+giCountSymbol  );


   return(0);
  }

//
int deinit()
  {
   return(0);
  }

//
int start()
  {
   int counted_bars=IndicatorCounted();
   

      Print(" > "+0+" "+sSymbol[0]+" "+giCountSymbol  );
      Print(" > "+1+" "+sSymbol[1]+" "+giCountSymbol  );
      Print(" > "+2+" "+sSymbol[2]+" "+giCountSymbol  );
      Print(" > "+3+" "+sSymbol[3]+" "+giCountSymbol  );
      Print(" > "+4+" "+sSymbol[4]+" "+giCountSymbol  );
      Print(" > "+5+" "+sSymbol[5]+" "+giCountSymbol  );
      Print(" > "+6+" "+sSymbol[6]+" "+giCountSymbol  );

   DrawSymbol();
      
   return(0);
  }


//
//    
//
void DrawSymbol()
{
    int i=0;
    int XD;
    int YD;
    YD = 10;
    color lColor;
    
    int indicatorWindow=0; //    

    for ( i = 0 ;  i < giCountSymbol; i++)
    {
      Print(" > "+i+" "+sSymbol[i]+" "+giCountSymbol  );
      if(ObjectFind( "o"+sSymbol[i] ) == -1 ) 
      {
         ObjectCreate( "o"+sSymbol[i]  , OBJ_LABEL, indicatorWindow ,  0, 0) ;
         if ( StringSubstr ( sSymbol[i],0,3)  == "USD")
         {
            XD = 5;
         }
         if ( StringSubstr ( sSymbol[i],3,3)  == "USD")
         {
            XD = 110;
         }
         
         ObjectSet("o"+sSymbol[i], OBJPROP_XDISTANCE, XD);
         ObjectSet("o"+sSymbol[i], OBJPROP_YDISTANCE, YD);
         ObjectSet("o"+sSymbol[i], OBJPROP_CORNER, 1);

         YD = YD + 14;
         
   
      }
      lColor = White;
      double prcCH = GetPrcCH(sSymbol[i]);
      if ( prcCH > 0 )
         lColor = Green;         
      if ( prcCH < 0 )   
         lColor = Red;
      ObjectSetText("o"+sSymbol[i], sSymbol[i] +" "+DoubleToStr(prcCH,3)+" ", 7, "Arial", lColor );
   }
}


//   -  
//          , SERGEEV
//
double   GetPrcCH( string sSymbol )
{
		double pc=iClose(sSymbol , PERIOD_D1,  1);
		double a=0;
		if (pc!= 0 ) 
		   a=(iClose(sSymbol,PERIOD_D1  ,0) * 100 ) / pc - 100;
      return (   a   );
}

